#include <JUI/Widgets/Image.hpp>
#include <SDL.h>
#include <SDL_image.h>

namespace JUI {
    Image::Image() : Widget()
    {

    }

    Image::Image(Widget* parent) : Image()
    {
        this->SetParent(parent);
    }

    Image::Image(Widget* parent, SDL_Texture* texture) : Image(parent)
    {
        this->texture = texture;
    }

    void Image::Update(double delta)
    {
        Widget::Update(delta);
    }

    v2f Image::GetAbsoluteSize() const
    { return this->GetParent()->GetAbsoluteSize(); }

    v2f Image::GetAbsolutePosition() const { return this->GetParent()->GetAbsolutePosition(); }

    void Image::Draw(SDL_Renderer *renderer) {
        Widget::Draw(renderer);

        /*auto image_dimensions = GetDimensions();
        auto abs_pos = GetAbsolutePosition();
        auto abs_size = GetAbsoluteSize();

        //SDL_Rect source_rect = {0, 0, image_dimensions.x, image_dimensions.y};
        SDL_Rect output_rect = {
                static_cast<int>(abs_pos.x),
                static_cast<int>(abs_pos.y),
                static_cast<int>(abs_size.x),
                static_cast<int>(abs_size.y)};



        SDL_RenderCopy(renderer, this->texture, &source_rect, &output_rect);
        */
    }


    //Image::Image(SDL_Renderer* renderer, std::string path) {
        //this->texture = IMG_LoadTexture(renderer, path.c_str());
    //}



}; // UTF8 Causes Methamphetamine Addiction