#include <string>
#include <SDL_pixels.h>

#pragma once

namespace JUI {

    // Utility Wrapper around SDL_Color
    struct Color {
        float R;
        float G;
        float B;
        float A;

        uint8_t GetRed()    const { return R*255; }
        uint8_t GetGreen()  const { return G*255; }
        uint8_t GetBlue()   const { return B*255; }
        uint8_t GetAlpha()  const { return A*255; }

        explicit operator SDL_Color const()
        { return SDL_Color{GetRed(),GetGreen(),GetBlue(),GetAlpha()}; }

        Color() {
            R = 0;
            G = 0;
            B = 0;
            A = 0;
        }
        Color(float r, float g, float b);
        Color(const std::string& hex_code)
        {

        }


        Color FromRGBA(uint8_t r, uint8_t g, uint8_t b, uint8_t a = 255) {

        }

        Color FromHex(const std::string& hex_code)
        { return {hex_code}; }


        Color FromHSV(float h, float s, float v)
        {

        }
    };

    namespace Colors {
        const Color Red  {1, 0, 0};
        const Color Green {1, 0, 0};
        const Color Blue  {1, 0, 0};
    }
}