/// @file ScrollableRect.hpp
/// @description Scrollable Rect (Canvas) Class
/// @author Joshua O'Leary
/// @revision 1
/// @edited 2023-08-19
/// @copyright (c) 2023 Conarium Software
/// @license Unlicense - Public Domain

#pragma once

#include <JUI/Widgets/Widget.hpp>
#include <JUI/Widgets/Rect.hpp>
#include <JUI/Widgets/Slider.hpp>

namespace JUI {
    class ScrollableRect : public Rect
    {
    public:
#pragma region Interface
        UDim2 CanvasSize;
        UDim2 CanvasPosition;
        v2f CanvasScale;
        bool Draggable;
        bool AutoSizeToContent;

#pragma region Constructors


#pragma endregion

#pragma region


#pragma endregion

#pragma region Implementation

    protected:
        Slider child_VSlider;
        Slider child_HSlider;
    private:

#pragma endregion
    };

}


