#pragma once

#include <JUI/Widgets/Widget.hpp>

#include <JUI/Types/Font.hpp>
#include <JUI/Widgets/Base/TextBase.hpp>

namespace JUI {
    // Text Widget -  Expands to fill the size of the parent Container
    // TODO: Rich Text Support
    // TODO: Implement expected behavior of padding on text layout.
    class Text : public Widget, public TextBase {
#pragma region Interface
    public:
#pragma region Constructors
        Text();
        explicit Text(Widget* parent);
        Text(Widget* parent, const std::string& text);
        ~Text() override;
#pragma endregion
#pragma region Member Methods
#pragma region Getters
        v2f GetAbsoluteSize()     const override;
        v2f GetAbsolutePosition() const override;
#pragma endregion
#pragma region Setters
#pragma endregion
        void Draw(SDL_Renderer *target) override;
        void Update(double delta) override;
#pragma endregion
#pragma endregion
#pragma region Internals
    protected:
    private:
#pragma endregion
    };
}