#include "Demos/MockMenu/JUIDemoGame.hpp"
#include <chrono>

int main() {

    std::cout << SDL_GetBasePath() << std::endl;


    using std::literals::chrono_literals::operator""ms;

    auto *game = new JUIDemoGame();
    game->KeyPressed += [](SDL_KeyboardEvent e){
        if (e.keysym.sym == SDLK_f)
        {
            std::cout << "HELLO" << std::endl;
        }
    };

    game->Initialize();
    game->Run();
    game->Cleanup();
    delete game;
    return 0;
}