#include <JUI/Widgets/CanvasRect.hpp>


namespace JUI
{

    SDL_BlendMode CanvasRect::GetBlendingMode() const {
        SDL_BlendMode mode{};
        int result = SDL_GetSurfaceBlendMode(surface, &mode);
        if (result == 0)
            return mode;
        else
            return SDL_BLENDMODE_NONE;
    }

    void CanvasRect::SetBlendingMode(SDL_BlendMode blend) {
        SDL_SetSurfaceBlendMode(surface, blend);
    }
}