
#include <JUI/Widgets/Scene.hpp>

namespace JUI
{
    void Scene::Update(double delta)
    {
        this->UpdateChildWidgets(delta);
    }

    v2f Scene::GetAbsolutePosition() const {
        return {0, 0};
    }

    // TODO: Should return window size
    v2f Scene::GetAbsoluteSize() const {
        int x;
        int y;
        SDL_GetWindowSize(window, &x, &y);
        return {x, y};
    }

    Scene::Scene() : Widget() {

    }

    Scene::Scene(SDL_Window *wnd, SDL_Renderer *rend) : Widget(), window(wnd), renderer(rend) {}

    void Scene::Draw() { Draw(renderer); }

    void Scene::Draw(SDL_Renderer *target) {
        Widget::Draw(target);
    }
}